/***************************************************************************
 *   Copyright (C) 2004 by Daniel Muller                                   *
 *   dan at verliba dot cz                                                 *
 *                                                                         *
 *   This program is free software; you can redistribute it and/or modify  *
 *   it under the terms of the GNU General Public License as published by  *
 *   the Free Software Foundation; either version 2 of the License, or     *
 *   (at your option) any later version.                                   *
 *                                                                         *
 *   This program is distributed in the hope that it will be useful,       *
 *   but WITHOUT ANY WARRANTY; without even the implied warranty of        *
 *   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the         *
 *   GNU General Public License for more details.                          *
 *                                                                         *
 *   You should have received a copy of the GNU General Public License     *
 *   along with this program; if not, write to the                         *
 *   Free Software Foundation, Inc.,                                       *
 *   59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.             *
 ***************************************************************************/
#ifdef HAVE_CONFIG_H
#include <config.h>
#endif
#include <cconndc.h>
#include "cconsole.h"
#include "cpiplug.h"
#include "cplugs.h"

using namespace nDirectConnect;


cPlugs *cPlugConsole::GetTheList()
{
	return mOwner->mList;
}

void cPlugConsole::ListHead(ostream *os)
{
	(*os) << "PlugMan version(" << mOwner->Version() << ")\r\n"
		"Verlihub executable: " << mOwner->mServer->mExecPath << "\r\n"
		"Verlihub make-time: " << cTime(mOwner->mList->mVHTime,0).AsDate() << "\r\n"
		"\r\n";
}

const char *cPlugConsole::CmdSuffix()
{
	return "plug";
}

const char *cPlugConsole::CmdPrefix()
{
	return "!";
}

const char * cPlugConsole::GetParamsRegex(int cmd)
{
	/**
	 * syntax of commands:
	 * !lstpi
	 * !addpi <nick<8> <"path">[ <desc>]
	 * !delplug <ipmin_or_iprange>
	 **/
	switch(cmd)
	{
		case eLC_ADD: 
			return "^(\\S{1,8}) " // <nick>
			      "(\")?((?(2)[^\"]+?|\\S+))(?(2)\")" // <"path">
			      "( (.*))?" // [ <desc>]
			      "$" // the end of message
			      ; break;
		case eLC_DEL: return "(\\S+)"; break;
		default : return ""; break;
	};
}

bool cPlugConsole::ReadDataFromCmd(cfBase *cmd, int id, cPlug &data)
{
	/// regex parts for add command
	enum {aADD_ALL, eADD_NICK, eADD_QUOTE, eADD_PATH, eADD_DESCP, eADD_DESC	};
	
	cmd->GetParStr(eADD_NICK, data.mNick);
	cmd->GetParUnEscapeStr(eADD_PATH, data.mPath);
	cmd->GetParStr(eADD_DESC, data.mDesc);
	return true;	
}

cPlugConsole::~cPlugConsole(){}

